﻿using GeometryFriendsAgents.WorldObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GeometryFriendsAgents.GameStates {
    class FifthGameState : GameState {

        private float _xPos;

        public float xPos {
            get { return _xPos; }
        }

        private float _xSpeed;

        public float xSpeed {
            get { return _xSpeed; }
        }

        private Collectible _closestCollectible;

        public Collectible ClosestCollectible {
            get { return _closestCollectible; }
        }



        public FifthGameState(float xPos, float xSpeed, Collectible closestCollectible) {
            _xPos = xPos;
            _xSpeed = xSpeed;
            _closestCollectible = closestCollectible;
        }

        public int GetStateId() {
            int agentPosition = CalculatePercentage(xPos);

            int collectiblePosition = CalculatePercentage(ClosestCollectible.xPos);

            int percentageNorm = (int)Math.Sqrt(Math.Pow(agentPosition - collectiblePosition,2));

            int unitVector;
            if (percentageNorm == 0) {
                unitVector = 0;
            } else {
                unitVector = (agentPosition - collectiblePosition) / percentageNorm;
            }
            return (((int)Math.Abs(xSpeed)).ToString() + "/" + (unitVector.ToString()) + "/" + collectiblePosition.ToString()).GetHashCode() ;
        }

        private int CalculatePercentage(float xPosition) {
            int agentPosition = (int)((xPosition / WorldModel.GetInstance().Area.Width) * 100);
            return agentPosition;
        }
    }
}
